{****************************************************************************}
                                  Unit sbFile;
{*****************************************************************************
                                   SBFILE.PAS
                               Borland Pascal unit
                                      1.02
                               (c)1998 SoulBurner
*****************************************************************************}
                                    Interface
{****************************************************************************}
Uses Dos;
{****************************************************************************}
  Function  UpCaseStr(s: string): string;

  Function  sbOpenFileforReading(Var f: file; flnm: string): boolean;
  Procedure sbScanFiles(mask: string);
  Procedure sbSortByExtension;
  Procedure sbSortByName;
  Procedure sbErase(flnm: string);
  Procedure sbRename(f1,f2: string);
{****************************************************************************}
Type
       FileFullNameT = record
                         name: string[8];
                          ext: string[3];
                       end;
       dword = longint;
{****************************************************************************}
Var
          flnms: array[0..255] of FileFullNameT;
       filesnum: byte;

            tsr: SearchRec;
{****************************************************************************}
                                 Implementation
{****************************************************************************}
Function UpCaseStr(s: string): string;

Var
     i: byte;
    s2: string;

Begin

  s2:='';
  for i:=1 to Length(s) do
    s2:=s2+UpCase(s[i]);

  UpCaseStr:=s2;

End;
{****************************************************************************}
Procedure sbErase(flnm: string);

Var
    f: file;

Begin

  Assign(f,flnm); Erase(f);

End;
{****************************************************************************}
Procedure sbRename(f1,f2: string);

Var
    f: file;

Begin

  Assign(f,f1); Rename(f,f2);

End;
{****************************************************************************}
Function sbOpenFileforReading(Var f: file; flnm: string): boolean;

Begin

  Assign(f,flnm); {$I-} Reset(f,1); {$I+}
  if IOResult<>0 then begin
                        sbOpenFileforReading:=false;
                        Exit;
                      end;

  sbOpenFileforReading:=true;

End;
{****************************************************************************}
Procedure sbScanFiles(mask: string);

Begin

  filesnum:=0;
  FindFirst(mask,$3F,tsr);
  while DosError=0 do
  begin
    Inc(filesnum);
    flnms[filesnum].name:=UpCaseStr(Copy(tsr.name,1,Pos('.',tsr.name)-1));
    flnms[filesnum].ext:=UpCaseStr(Copy(tsr.name,Pos('.',tsr.name)+1,3));
    FindNext(tsr);
  end;

End;
{****************************************************************************}
Procedure sbSortByName;

Var
      i,j: byte;
        a: FileFullNameT;

Begin

  for i:=1 to filesnum do
    for j:=1 to filesnum do
      if flnms[i].name<flnms[j].name then
      begin
        a:=flnms[i]; flnms[i]:=flnms[j]; flnms[j]:=a;
      end;

End;
{****************************************************************************}
Procedure sbSortByExtension;

Var
      i,j: byte;
        a: FileFullNameT;

Begin

  for i:=1 to filesnum do
    for j:=1 to filesnum do
      if flnms[i].ext<flnms[j].ext then
      begin
        a:=flnms[i]; flnms[i]:=flnms[j]; flnms[j]:=a;
      end;

End;
{****************************************************************************}
Begin

  filesnum:=0;

End.
{****************************************************************************}